package com.ejie.ab63.model;

import java.util.Date;

import com.ejie.ab63.model.terceros.DatosDirecciones;
import com.ejie.ab63.model.terceros.DatosTerceros;
import com.ejie.ab63.model.terceros.TiposTercero;
import com.ejie.x38.serialization.JsonDateDeserializer;
import com.ejie.x38.serialization.JsonDateSerializer;
import com.fasterxml.jackson.databind.annotation.JsonDeserialize;
import com.fasterxml.jackson.databind.annotation.JsonSerialize;

/**
 * Ab6339s00  
 * 
 *  
 */

public class TercerosEstablecimiento implements java.io.Serializable {

	private static final long serialVersionUID = 3460343016141483271L;
	private Integer idTercerosEstab;
	private Establecimiento establecimiento;
	private Date fechaRegistro;
	private String usuarioRegistro;
	private Date fechaUltmodificacion;
	private String usuarioUltmodificacion;
	private TiposTercero tiposTercero;
	private Integer baja;
	private String descripcionBaja;
	private Long idTipoTerceroAnt;
	private String documentoAnt;

	private DatosTerceros datosTerceros;
	private DatosDirecciones datosDirecciones;

	/**
	 * Method 'Ab6339s00'.
	 */
	public TercerosEstablecimiento() {
	}

	/**
	 * Method 'Ab6339s00'.
	 * 
	 * @param idTercerosEstab
	 *            Integer
	 */
	public TercerosEstablecimiento(Integer idTercerosEstab) {
		this.idTercerosEstab = idTercerosEstab;
	}

	/**
	 * Method 'Ab6339s00'.
	 * 
	 * @param idTercerosEstab
	 *            Integer
	 * @param fechaRegistro
	 *            Date
	 * @param usuarioRegistro
	 *            String
	 * @param fechaUltmodificacion
	 *            Date
	 * @param usuarioUltmodificacion
	 *            String
	 * @param ab6301s00
	 *            Ab6301s00
	 */
	public TercerosEstablecimiento(Integer idTercerosEstab, Date fechaRegistro, String usuarioRegistro,
			Date fechaUltmodificacion, String usuarioUltmodificacion, Establecimiento ab6301s00, TiposTercero ab6106,
			Integer baja) {

		this.idTercerosEstab = idTercerosEstab;
		this.establecimiento = ab6301s00;
		this.fechaRegistro = fechaRegistro;
		this.usuarioRegistro = usuarioRegistro;
		this.fechaUltmodificacion = fechaUltmodificacion;
		this.usuarioUltmodificacion = usuarioUltmodificacion;
		this.tiposTercero = ab6106;
		this.baja = baja;
	}

	public TercerosEstablecimiento(Integer idTercerosEstab, Date fechaRegistro, String usuarioRegistro,
			Date fechaUltmodificacion, String usuarioUltmodificacion, Establecimiento ab6301s00, TiposTercero ab6106,
			DatosTerceros datosTerceros) {

		this.idTercerosEstab = idTercerosEstab;
		this.establecimiento = ab6301s00;
		this.fechaRegistro = fechaRegistro;
		this.usuarioRegistro = usuarioRegistro;
		this.fechaUltmodificacion = fechaUltmodificacion;
		this.usuarioUltmodificacion = usuarioUltmodificacion;
		this.tiposTercero = ab6106;
		this.datosTerceros = datosTerceros;
	}

	public TercerosEstablecimiento(Integer idTercerosEstab, Date fechaRegistro, String usuarioRegistro,
			Date fechaUltmodificacion, String usuarioUltmodificacion, Establecimiento ab6301s00, TiposTercero ab6106,
			DatosTerceros datosTerceros, DatosDirecciones datosDirecciones) {

		this.idTercerosEstab = idTercerosEstab;
		this.establecimiento = ab6301s00;
		this.fechaRegistro = fechaRegistro;
		this.usuarioRegistro = usuarioRegistro;
		this.fechaUltmodificacion = fechaUltmodificacion;
		this.usuarioUltmodificacion = usuarioUltmodificacion;
		this.tiposTercero = ab6106;
		this.datosTerceros = datosTerceros;
		this.setDatosDirecciones(datosDirecciones);
	}

	/**
	 * Method 'getIdTercerosEstab'.
	 *
	 * @return Integer
	 */

	public Integer getIdTercerosEstab() {
		return this.idTercerosEstab;
	}

	/**
	 * Method 'setIdTercerosEstab'.
	 *
	 * @param idTercerosEstab
	 *            Integer
	 * @return
	 */

	public void setIdTercerosEstab(Integer idTercerosEstab) {
		this.idTercerosEstab = idTercerosEstab;
	}

	/**
	 * Method 'getAb6301s00'.
	 *
	 * @return Ab6301s00
	 */

	public Establecimiento getEstablecimiento() {
		return this.establecimiento;
	}

	/**
	 * Method 'setAb6301s00'.
	 *
	 * @param ab6301s00
	 *            Ab6301s00
	 * @return
	 */

	public void setEstablecimiento(Establecimiento ab6301s00) {
		this.establecimiento = ab6301s00;
	}

	/**
	 * Method 'getFechaRegistro'.
	 *
	 * @return java.util.Date
	 */

	@JsonSerialize(using = JsonDateSerializer.class)
	public Date getFechaRegistro() {
		return this.fechaRegistro;
	}

	/**
	 * Method 'setFechaRegistro'.
	 *
	 * @param fechaRegistro
	 *            java.util.Date
	 * @return
	 */
	@JsonDeserialize(using = JsonDateDeserializer.class)
	public void setFechaRegistro(Date fechaRegistro) {
		this.fechaRegistro = fechaRegistro;
	}

	/**
	 * Method 'getUsuarioRegistro'.
	 *
	 * @return String
	 */

	public String getUsuarioRegistro() {
		return this.usuarioRegistro;
	}

	/**
	 * Method 'setUsuarioRegistro'.
	 *
	 * @param usuarioRegistro
	 *            String
	 * @return
	 */

	public void setUsuarioRegistro(String usuarioRegistro) {
		this.usuarioRegistro = usuarioRegistro;
	}

	/**
	 * Method 'getFechaUltmodificacion'.
	 *
	 * @return java.util.Date
	 */

	@JsonSerialize(using = JsonDateSerializer.class)
	public Date getFechaUltmodificacion() {
		return this.fechaUltmodificacion;
	}

	/**
	 * Method 'setFechaUltmodificacion'.
	 *
	 * @param fechaUltmodificacion
	 *            java.util.Date
	 * @return
	 */
	@JsonDeserialize(using = JsonDateDeserializer.class)
	public void setFechaUltmodificacion(Date fechaUltmodificacion) {
		this.fechaUltmodificacion = fechaUltmodificacion;
	}

	/**
	 * Method 'getUsuarioUltmodificacion'.
	 *
	 * @return String
	 */

	public String getUsuarioUltmodificacion() {
		return this.usuarioUltmodificacion;
	}

	/**
	 * Method 'setUsuarioUltmodificacion'.
	 *
	 * @param usuarioUltmodificacion
	 *            String
	 * @return
	 */

	public void setUsuarioUltmodificacion(String usuarioUltmodificacion) {
		this.usuarioUltmodificacion = usuarioUltmodificacion;
	}

	public TiposTercero getTiposTercero() {
		return tiposTercero;
	}

	public void setTiposTercero(TiposTercero tiposTercero) {
		this.tiposTercero = tiposTercero;
	}

	public Integer getBaja() {
		return baja;
	}

	public void setBaja(Integer baja) {
		this.baja = baja;
	}

	public String getDescripcionBaja() {
		return descripcionBaja;
	}

	public void setDescripcionBaja(String descripcionBaja) {
		this.descripcionBaja = descripcionBaja;
	}

	/**
	 * Intended only for logging and debugging.
	 * 
	 * Here, the contents of every main field are placed into the result.
	 * 
	 * @return String
	 */
	@Override
	public String toString() {
		StringBuilder result = new StringBuilder();
		result.append(this.getClass().getName()).append(" Object { ");
		result.append(" [ idTercerosEstab: ").append(this.idTercerosEstab).append(" ]");
		result.append(", [ fechaRegistro: ").append(this.fechaRegistro).append(" ]");
		result.append(", [ usuarioRegistro: ").append(this.usuarioRegistro).append(" ]");
		result.append(", [ fechaUltmodificacion: ").append(this.fechaUltmodificacion).append(" ]");
		result.append(", [ usuarioUltmodificacion: ").append(this.usuarioUltmodificacion).append(" ]");
		result.append("}");
		return result.toString();
	}

	public DatosTerceros getDatosTerceros() {
		return datosTerceros;
	}

	public void setDatosTerceros(DatosTerceros datosTercero) {
		this.datosTerceros = datosTercero;
	}

	public Long getIdTipoTerceroAnt() {
		return idTipoTerceroAnt;
	}

	public void setIdTipoTerceroAnt(Long idTipoTerceroAnt) {
		this.idTipoTerceroAnt = idTipoTerceroAnt;
	}

	public String getDocumentoAnt() {
		return documentoAnt;
	}

	public void setDocumentoAnt(String documentoAnt) {
		this.documentoAnt = documentoAnt;
	}

	/**
	 * @return the datosDirecciones
	 */
	public DatosDirecciones getDatosDirecciones() {
		return datosDirecciones;
	}

	/**
	 * @param datosDirecciones
	 *            the datosDirecciones to set
	 */
	public void setDatosDirecciones(DatosDirecciones datosDirecciones) {
		this.datosDirecciones = datosDirecciones;
	}

}
